AIGameSettingControls.DefaultAttack = class extends AIGameSettingControlInt
{
	constructor(...args)
	{
		super(...args);
		this.defaultValue = 300;
		g_GameSettings.playerAI.watch(() => this.render(), ["values"]);
	}

	onOpenPage(playerIndex, enabled)
	{
		super.onOpenPage(playerIndex, enabled);
		this.render();
	}

	render()
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		this.setHidden(!ai);
		if (ai)
		{
			const value = ai.military?.defaultAttack ?? this.defaultValue;
			this.setIntValue(value);
		}
	}

	onValueChange(value)
	{
		const ai = g_GameSettings.playerAI.get(this.playerIndex);
		const military = ai && ai.military ? { ...ai.military, "defaultAttack": value } : { "defaultAttack": value };
		g_GameSettings.playerAI.setMilitary(this.playerIndex, military);
		this.gameSettingsController.setNetworkInitAttributes();
	}
};

AIGameSettingControls.DefaultAttack.prototype.TitleCaption =
	translate("Default Attack");
